"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const factory = () => {
    let buffer = Buffer.from([]);
    let cursor = 0;
    const until = (subject) => {
        const index = buffer.indexOf(subject, cursor);
        if (index === -1) {
            return false;
        }
        cursor = index + subject.length;
        return true;
    };
    const is = (subject) => {
        return buffer.equals(subject);
    };
    const concat = (chunk) => {
        buffer = Buffer.concat([buffer, chunk]);
        return context();
    };
    const slice = (length) => {
        const diff = buffer.slice(0, cursor + length);
        buffer = buffer.slice(cursor + length, buffer.length);
        cursor = 0;
        return diff;
    };
    const get = () => {
        return buffer;
    };
    const context = () => ({
        concat,
        slice,
        until,
        is,
        get,
    });
    return context();
};
exports.default = factory;
